#include "GPRSConnection.h"

#pragma warning(push, 3)
#include <windows.h>
#include <commctrl.h>
#include <initguid.h>
#include <connmgr.h>
#include <connmgr_status.h>
#include <connmgr_conntypes.h>
#include <ras.h>
#include <winsock2.h>
#pragma warning(pop)

GPRSConnection::GPRSConnection(void)
: _hConnection(INVALID_HANDLE_VALUE), _hConnMgr(INVALID_HANDLE_VALUE)
{
}

GPRSConnection::~GPRSConnection(void)
{
}

bool GPRSConnection::_connect()
{
  CONNMGR_CONNECTIONINFO ConnectionInfo;
  ZeroMemory (&ConnectionInfo, sizeof (ConnectionInfo));
  ConnectionInfo.cbSize = sizeof (ConnectionInfo);
  
  ConnectionInfo.dwParams = CONNMGR_PARAM_GUIDDESTNET; 
  ConnectionInfo.dwFlags = CONNMGR_FLAG_NO_ERROR_MSGS; 
  ConnectionInfo.dwPriority = CONNMGR_PRIORITY_HIPRIBKGND; 
  ConnectionInfo.guidDestNet = IID_DestNetInternet;
  
  DWORD dwStatus;
  HRESULT hr = ConnMgrEstablishConnectionSync (&ConnectionInfo, &_hConnection, 30000, &dwStatus);
  if (FAILED(hr))
  {
    return false;
  }
 
  return true;
}

bool GPRSConnection::_disconnect()
{
  HRESULT hr = ConnMgrReleaseConnection(_hConnection, FALSE);
  if (FAILED(hr))
  {
    return false;
  }
  
  return true;
}
